#include "transparent_shader_class.h"


transparent_shader_class::transparent_shader_class()
{
    vertex_shader_ = 0;
    pixel_shader_ = 0;
    layout_ = 0;
    matrix_buffer_ = 0;
    sample_state_ = 0;
    transparent_buffer_ = 0;
}


transparent_shader_class::transparent_shader_class(const transparent_shader_class& other)
{
}


transparent_shader_class::~transparent_shader_class()
{
}


bool transparent_shader_class::initialize(ID3D11Device* device, HWND hwnd)
{
    LOG_INIT("Initializing transparent_shader_class");

    bool result;
    wchar_t vsFilename[128];
    wchar_t psFilename[128];
    int error;

    // Set the filename of the vertex shader.
    error = wcscpy_s(vsFilename, 128, L"src/hlsl/transparent.vs");
    if (error != 0)
    {
        LOG_ERROR("Failed to copy vertex shader filename");
        R_FALSE
    }

    // Set the filename of the pixel shader.
    error = wcscpy_s(psFilename, 128, L"src/hlsl/transparent.ps");
    if (error != 0)
    {
        LOG_ERROR("Failed to copy pixel shader filename");
        R_FALSE
    }

    // Initialize the vertex and pixel shaders.
    result = initialize_shader(device, hwnd, vsFilename, psFilename);
    if (!result)
    {
        LOG_ERROR("Failed to initialize shader");
        R_FALSE
    }

    LOG_INIT("transparent_shader_class initialized");

    R_TRUE
}


void transparent_shader_class::shutdown()
{
    // shutdown the vertex and pixel shaders as well as the related objects.
    shutdown_shader();

    return;
}

bool transparent_shader_class::render(ID3D11DeviceContext* deviceContext, int indexCount, XMMATRIX worldMatrix, XMMATRIX viewMatrix,
    XMMATRIX projectionMatrix, ID3D11ShaderResourceView* texture, float blend)
{
    bool result;


    // Set the shader parameters that it will use for rendering.
    result = set_shader_parameters(deviceContext, worldMatrix, viewMatrix, projectionMatrix, texture, blend);
    if (!result)
    {
        LOG_ERROR("Failed to set shader parameters");
        R_FALSE
    }

    // Now render the prepared buffers with the shader.
    render_shader(deviceContext, indexCount);

    R_TRUE
}


bool transparent_shader_class::initialize_shader(ID3D11Device* device, HWND hwnd, WCHAR* vsFilename, WCHAR* psFilename)
{
    LOG_INIT("Initializing transparent shader");

    HRESULT result;
    ID3D10Blob* errorMessage;
    ID3D10Blob* vertexShaderBuffer;
    ID3D10Blob* pixelShaderBuffer;
    D3D11_INPUT_ELEMENT_DESC polygonLayout[2];
    unsigned int numElements;
    D3D11_BUFFER_DESC matrixBufferDesc;
    D3D11_SAMPLER_DESC samplerDesc;
    D3D11_BUFFER_DESC transparentBufferDesc;


    // initialize the pointers this function will use to null.
    errorMessage = 0;
    vertexShaderBuffer = 0;
    pixelShaderBuffer = 0;

    // Compile the vertex shader code.
    result = D3DCompileFromFile(vsFilename, NULL, NULL, "TransparentVertexShader", "vs_5_0", D3D10_SHADER_ENABLE_STRICTNESS, 0,
        &vertexShaderBuffer, &errorMessage);
    if (FAILED(result))
    {
        // If the shader failed to compile it should have writen something to the error message.
        if (errorMessage)
        {
            output_shader_error_message(errorMessage, hwnd, vsFilename);
        }
        // If there was nothing in the error message then it simply could not find the shader file itself.
        else
        {
            LOG_ERROR("Failed to compile vertex shader");
        }

        R_FALSE
    }

    // Compile the pixel shader code.
    result = D3DCompileFromFile(psFilename, NULL, NULL, "TransparentPixelShader", "ps_5_0", D3D10_SHADER_ENABLE_STRICTNESS, 0,
        &pixelShaderBuffer, &errorMessage);
    if (FAILED(result))
    {
        // If the shader failed to compile it should have writen something to the error message.
        if (errorMessage)
        {
            output_shader_error_message(errorMessage, hwnd, psFilename);
        }
        // If there was nothing in the error message then it simply could not find the file itself.
        else
        {
            LOG_ERROR("Failed to compile pixel shader");
        }

        R_FALSE
    }

    // Create the vertex shader from the buffer.
    result = device->CreateVertexShader(vertexShaderBuffer->GetBufferPointer(), vertexShaderBuffer->GetBufferSize(), NULL, &vertex_shader_);
    if (FAILED(result))
    {
        LOG_ERROR("Failed to create vertex shader");
        R_FALSE
    }

    // Create the pixel shader from the buffer.
    result = device->CreatePixelShader(pixelShaderBuffer->GetBufferPointer(), pixelShaderBuffer->GetBufferSize(), NULL, &pixel_shader_);
    if (FAILED(result))
    {
        LOG_ERROR("Failed to create pixel shader");
        R_FALSE
    }

    // Create the vertex input layout description.
    polygonLayout[0].SemanticName = "POSITION";
    polygonLayout[0].SemanticIndex = 0;
    polygonLayout[0].Format = DXGI_FORMAT_R32G32B32_FLOAT;
    polygonLayout[0].InputSlot = 0;
    polygonLayout[0].AlignedByteOffset = 0;
    polygonLayout[0].InputSlotClass = D3D11_INPUT_PER_VERTEX_DATA;
    polygonLayout[0].InstanceDataStepRate = 0;

    polygonLayout[1].SemanticName = "TEXCOORD";
    polygonLayout[1].SemanticIndex = 0;
    polygonLayout[1].Format = DXGI_FORMAT_R32G32_FLOAT;
    polygonLayout[1].InputSlot = 0;
    polygonLayout[1].AlignedByteOffset = D3D11_APPEND_ALIGNED_ELEMENT;
    polygonLayout[1].InputSlotClass = D3D11_INPUT_PER_VERTEX_DATA;
    polygonLayout[1].InstanceDataStepRate = 0;

    // Get a count of the elements in the layout.
    numElements = sizeof(polygonLayout) / sizeof(polygonLayout[0]);

    // Create the vertex input layout.
    result = device->CreateInputLayout(polygonLayout, numElements, vertexShaderBuffer->GetBufferPointer(),
        vertexShaderBuffer->GetBufferSize(), &layout_);
    if (FAILED(result))
    {
        LOG_ERROR("Failed to create input layout");
        R_FALSE
    }

    // Release the vertex shader buffer and pixel shader buffer since they are no longer needed.
    vertexShaderBuffer->Release();
    vertexShaderBuffer = 0;

    pixelShaderBuffer->Release();
    pixelShaderBuffer = 0;

    // Setup the description of the dynamic matrix constant buffer that is in the vertex shader.
    matrixBufferDesc.Usage = D3D11_USAGE_DYNAMIC;
    matrixBufferDesc.ByteWidth = sizeof(matrix_buffer_type);
    matrixBufferDesc.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
    matrixBufferDesc.CPUAccessFlags = D3D11_CPU_ACCESS_WRITE;
    matrixBufferDesc.MiscFlags = 0;
    matrixBufferDesc.StructureByteStride = 0;

    // Create the constant buffer pointer so we can access the vertex shader constant buffer from within this class.
    result = device->CreateBuffer(&matrixBufferDesc, NULL, &matrix_buffer_);
    if (FAILED(result))
    {
        LOG_ERROR("Failed to create matrix buffer");
        R_FALSE
    }

    // Create a texture sampler state description.
    samplerDesc.Filter = D3D11_FILTER_MIN_MAG_MIP_LINEAR;
    samplerDesc.AddressU = D3D11_TEXTURE_ADDRESS_WRAP;
    samplerDesc.AddressV = D3D11_TEXTURE_ADDRESS_WRAP;
    samplerDesc.AddressW = D3D11_TEXTURE_ADDRESS_WRAP;
    samplerDesc.MipLODBias = 0.0f;
    samplerDesc.MaxAnisotropy = 1;
    samplerDesc.ComparisonFunc = D3D11_COMPARISON_ALWAYS;
    samplerDesc.BorderColor[0] = 0;
    samplerDesc.BorderColor[1] = 0;
    samplerDesc.BorderColor[2] = 0;
    samplerDesc.BorderColor[3] = 0;
    samplerDesc.MinLOD = 0;
    samplerDesc.MaxLOD = D3D11_FLOAT32_MAX;

    // Create the texture sampler state.
    result = device->CreateSamplerState(&samplerDesc, &sample_state_);
    if (FAILED(result))
    {
        LOG_ERROR("Failed to create sampler state");
        R_FALSE
    }

    // Setup the description of the transparent dynamic constant buffer that is in the pixel shader.
    transparentBufferDesc.Usage = D3D11_USAGE_DYNAMIC;
    transparentBufferDesc.ByteWidth = sizeof(transparent_buffer_type);
    transparentBufferDesc.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
    transparentBufferDesc.CPUAccessFlags = D3D11_CPU_ACCESS_WRITE;
    transparentBufferDesc.MiscFlags = 0;
    transparentBufferDesc.StructureByteStride = 0;

    // Create the constant buffer pointer so we can access the pixel shader constant buffer from within this class.
    result = device->CreateBuffer(&transparentBufferDesc, NULL, &transparent_buffer_);
    if (FAILED(result))
    {
        LOG_ERROR("Failed to create transparent buffer");
        R_FALSE
    }

    LOG_INIT("Transparent shader initialized");

    R_TRUE
}


void transparent_shader_class::shutdown_shader()
{
    LOG_SHUTDOWN("Shutting down transparent shader");

    // Release the transparent constant buffer.
    if (transparent_buffer_)
    {
        transparent_buffer_->Release();
        transparent_buffer_ = 0;
    }

    // Release the sampler state.
    if (sample_state_)
    {
        sample_state_->Release();
        sample_state_ = 0;
    }

    // Release the matrix constant buffer.
    if (matrix_buffer_)
    {
        matrix_buffer_->Release();
        matrix_buffer_ = 0;
    }

    // Release the layout.
    if (layout_)
    {
        layout_->Release();
        layout_ = 0;
    }

    // Release the pixel shader.
    if (pixel_shader_)
    {
        pixel_shader_->Release();
        pixel_shader_ = 0;
    }

    // Release the vertex shader.
    if (vertex_shader_)
    {
        vertex_shader_->Release();
        vertex_shader_ = 0;
    }

    LOG_SHUTDOWN("Transparent shader shut down");

    return;
}


void transparent_shader_class::output_shader_error_message(ID3D10Blob* errorMessage, HWND hwnd, WCHAR* shaderFilename)
{
    char* compileErrors;
    unsigned long long bufferSize, i;
    ofstream fout;


    // Get a pointer to the error message text buffer.
    compileErrors = (char*)(errorMessage->GetBufferPointer());

    // Get the length of the message.
    bufferSize = errorMessage->GetBufferSize();

    // Open a file to write the error message to.
    fout.open("shader-error.txt");

    // Write out the error message.
    for (i = 0; i < bufferSize; i++)
    {
        fout << compileErrors[i];
    }

    // Close the file.
    fout.close();

    // Release the error message.
    errorMessage->Release();
    errorMessage = 0;

    // Pop a message up on the screen to notify the user to check the text file for compile errors.
    MessageBox(hwnd, L"Error compiling shader.  Check shader-error.txt for message.", shaderFilename, MB_OK);

    return;
}

bool transparent_shader_class::set_shader_parameters(ID3D11DeviceContext* deviceContext, XMMATRIX worldMatrix, XMMATRIX viewMatrix,
    XMMATRIX projectionMatrix, ID3D11ShaderResourceView* texture, float blend)
{
    HRESULT result;
    D3D11_MAPPED_SUBRESOURCE mappedResource;
    matrix_buffer_type* dataPtr;
    unsigned int bufferNumber;
    transparent_buffer_type* dataPtr2;


    // Transpose the matrices to prepare them for the shader.
    worldMatrix = XMMatrixTranspose(worldMatrix);
    viewMatrix = XMMatrixTranspose(viewMatrix);
    projectionMatrix = XMMatrixTranspose(projectionMatrix);

    // Lock the constant buffer so it can be written to.
    result = deviceContext->Map(matrix_buffer_, 0, D3D11_MAP_WRITE_DISCARD, 0, &mappedResource);
    if (FAILED(result))
    {
        LOG_ERROR("Failed to map matrix buffer");
        R_FALSE
    }

    // Get a pointer to the data in the constant buffer.
    dataPtr = (matrix_buffer_type*)mappedResource.pData;

    // Copy the matrices into the constant buffer.
    dataPtr->world = worldMatrix;
    dataPtr->view = viewMatrix;
    dataPtr->projection = projectionMatrix;

    // Unlock the constant buffer.
    deviceContext->Unmap(matrix_buffer_, 0);

    // Set the position of the constant buffer in the vertex shader.
    bufferNumber = 0;

    // Finally set the constant buffer in the vertex shader with the updated values.
    deviceContext->VSSetConstantBuffers(bufferNumber, 1, &matrix_buffer_);

    // Set shader texture resource in the pixel shader.
    deviceContext->PSSetShaderResources(0, 1, &texture);

    // Lock the transparent constant buffer so it can be written to.
    result = deviceContext->Map(transparent_buffer_, 0, D3D11_MAP_WRITE_DISCARD, 0, &mappedResource);
    if (FAILED(result))
    {
        LOG_ERROR("Failed to map transparent buffer");
        R_FALSE
    }

    // Get a pointer to the data in the transparent constant buffer.
    dataPtr2 = (transparent_buffer_type*)mappedResource.pData;

    // Copy the alpha blending value into the transparent constant buffer.
    dataPtr2->blend_amount = blend;

    // Unlock the buffer.
    deviceContext->Unmap(transparent_buffer_, 0);

    // Set the position of the transparent constant buffer in the pixel shader.
    bufferNumber = 0;

    // Now set the transparent constant buffer in the pixel shader with the updated values.
    deviceContext->PSSetConstantBuffers(bufferNumber, 1, &transparent_buffer_);

    R_TRUE
}


void transparent_shader_class::render_shader(ID3D11DeviceContext* deviceContext, int indexCount)
{
    // Set the vertex input layout.
    deviceContext->IASetInputLayout(layout_);

    // Set the vertex and pixel shaders that will be used to render the geometry.
    deviceContext->VSSetShader(vertex_shader_, NULL, 0);
    deviceContext->PSSetShader(pixel_shader_, NULL, 0);

    // Set the sampler state in the pixel shader.
    deviceContext->PSSetSamplers(0, 1, &sample_state_);

    // render the geometry.
    deviceContext->DrawIndexed(indexCount, 0, 0);

    return;
}